/*
 * Copyright  2006 Sun Microsystems, Inc. All rights reserved. 
 * 
 * Sun Microsystems, Inc. has intellectual property rights relating to technology embodied in the product that is
 * described in this document. In particular, and without limitation, these intellectual property rights may
 * include one or more of the U.S. patents listed at http://www.sun.com/patents and one or more additional patents
 * or pending patent applications in the U.S. and in other countries.
 * 
 * U.S. Government Rights - Commercial software. Government users are subject to the Sun Microsystems, Inc.
 * standard license agreement and applicable provisions of the FAR and its supplements.
 * 
 * Use is subject to license terms. 
 * 
 * This distribution may include materials developed by third parties.Sun, Sun Microsystems, the Sun logo and
 * Java are trademarks or registered trademarks of Sun Microsystems, Inc. in the U.S. and other countries. 
 * 
 * Copyright  2006 Sun Microsystems, Inc. Tous droits rservs.
 * 
 * Sun Microsystems, Inc. dtient les droits de proprit intellectuels relatifs  la technologie incorpore dans
 * le produit qui est dcrit dans ce document. En particulier, et ce sans limitation, ces droits de proprit
 * intellectuelle peuvent inclure un ou plus des brevets amricains lists  l'adresse http://www.sun.com/patents
 * et un ou les brevets supplmentaires ou les applications de brevet en attente aux Etats - Unis et dans les
 * autres pays.
 * 
 * L'utilisation est soumise aux termes du contrat de licence.
 * 
 * Cette distribution peut comprendre des composants dvelopps par des tierces parties.
 * Sun, Sun Microsystems, le logo Sun et Java sont des marques de fabrique ou des marques dposes de Sun
 * Microsystems, Inc. aux Etats-Unis et dans d'autres pays.
 */
package com.sun.spot.peripheral.basestation;

import java.io.IOException;

import com.sun.spot.peripheral.Spot;
import com.sun.spot.peripheral.radio.SpotSerialPipe;

/**
 * This class implements a base station that allows a PC (the "host") to communicate
 * to a standalone Spot ("the target") through a second Spot (the "base station")
 * connected to the host via a test board and usb cable.<br><br>
 * 
 * To write applications for the host, use the hostagent jar supplied in the devkit. Target Spots should 
 * be addressed directly from the host using their IEEE addresses. The target spots
 * should address the base station's IEEE address - the host doesn't expose an address
 * to the wider network.<br><br>
 * 
 * See "Spot Base Station.doc" for further guidance.<br>
 */
public class BaseStation {

	/**
	 * A main method that allows this class to be used as a startup class
	 * 	 
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		// Disable deep sleep as base stations can't, and there's 2% performance to gain
		Spot.getInstance().getSleepManager().disableDeepSleep();
		new MACProxyServer(new SpotSerialPipe()).run();
	}
}
