/*
 * Copyright  2006 Sun Microsystems, Inc. All rights reserved. 
 * 
 * Sun Microsystems, Inc. has intellectual property rights relating to technology embodied in the product that is
 * described in this document. In particular, and without limitation, these intellectual property rights may
 * include one or more of the U.S. patents listed at http://www.sun.com/patents and one or more additional patents
 * or pending patent applications in the U.S. and in other countries.
 * 
 * U.S. Government Rights - Commercial software. Government users are subject to the Sun Microsystems, Inc.
 * standard license agreement and applicable provisions of the FAR and its supplements.
 * 
 * Use is subject to license terms. 
 * 
 * This distribution may include materials developed by third parties.Sun, Sun Microsystems, the Sun logo and
 * Java are trademarks or registered trademarks of Sun Microsystems, Inc. in the U.S. and other countries. 
 * 
 * Copyright  2006 Sun Microsystems, Inc. Tous droits rservs.
 * 
 * Sun Microsystems, Inc. dtient les droits de proprit intellectuels relatifs  la technologie incorpore dans
 * le produit qui est dcrit dans ce document. En particulier, et ce sans limitation, ces droits de proprit
 * intellectuelle peuvent inclure un ou plus des brevets amricains lists  l'adresse http://www.sun.com/patents
 * et un ou les brevets supplmentaires ou les applications de brevet en attente aux Etats - Unis et dans les
 * autres pays.
 * 
 * L'utilisation est soumise aux termes du contrat de licence.
 * 
 * Cette distribution peut comprendre des composants dvelopps par des tierces parties.
 * Sun, Sun Microsystems, le logo Sun et Java sont des marques de fabrique ou des marques dposes de Sun
 * Microsystems, Inc. aux Etats-Unis et dans d'autres pays.
 */
package com.sun.spot.peripheral.basestation;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import com.sun.spot.peripheral.radio.I802_15_4_MAC;
import com.sun.spot.util.Utils;

public class MLMEGetCommand extends MACCommand {
	private int attribute;
	private long preparedResult;

	public MLMEGetCommand with(int attribute) {
		this.attribute = attribute;
		return this;
	}

	protected void writeParametersOnto(DataOutputStream dataOutputStream) throws IOException {
		dataOutputStream.writeInt(attribute);
	}

	public void populateFrom(byte[] inputBuffer, int startingOffset) throws IOException {
		attribute = Utils.readBigEndInt(inputBuffer, startingOffset);
	}

	protected void prepareResultOrExecute(I802_15_4_MAC mac) {
		preparedResult = mac.mlmeGet(attribute);
	}

	protected int writePreparedResult(byte[] outputBuffer, int startingOffset)  throws IOException {
		Utils.writeBigEndLong(outputBuffer, startingOffset, preparedResult);
		return 8;
	}

	protected Object readResultFrom(DataInputStream dataInputStream) throws IOException {
		return new Long(dataInputStream.readLong());
	}
	
	protected byte classIndicatorByte() {
		return MLMEGetCommand;
	}
}
